; Source created with Parsic Version 3.x

; at              : 08/01/03 10.55.40


; Project File    : C:\PROGRA~1\PARSIC\VARI\BOOLEANE.PIC

; Project Version : 1.0.11

; Created         : 12/10/01 17.42.00

; Last change     : 08/01/03 10.55.31

	PROCESSOR 16F84

	INCLUDE P16F84.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

SYS_TMP1	= 12	; located in Bank 0, 1
S0	= 13	; located in Bank 0, 1
RAM	= 14	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP
	RETURN

;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00000000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'01101010'
	MOVWF PORTB

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1

	MOVLW B'00000001'
	MOVWF S0


;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS PORTA,1
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF PORTB,0
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
LABEL_LG1_ENDE
;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS PORTA,0
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BTFSS PORTA,1
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BCF PORTB,1
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,1
LABEL_LG2_ENDE
;***************************************************
; ODER - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSC PORTA,0
	GOTO LABEL_LG3_TRUE
LABEL_LG3_2
	BTFSC PORTA,1
	GOTO LABEL_LG3_TRUE

LABEL_LG3_FALSE
	BCF PORTB,2
	GOTO LABEL_LG3_ENDE
LABEL_LG3_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,2
LABEL_LG3_ENDE
;***************************************************
; ODER - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSC PORTA,0
	GOTO LABEL_LG4_TRUE
LABEL_LG4_2
	BTFSC PORTA,1
	GOTO LABEL_LG4_TRUE

LABEL_LG4_FALSE
	BSF PORTB,3
	GOTO LABEL_LG4_ENDE
LABEL_LG4_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,3
LABEL_LG4_ENDE
;***************************************************
; EXKLUSIVODER - Gatter -> LG5
;***************************************************

	CLRF SYS_TMP1
	BTFSS PORTA,0
	GOTO LABEL_LG5_1
	INCF SYS_TMP1,F

LABEL_LG5_1
	BTFSS PORTA,1
	GOTO LABEL_LG5_2
	INCF SYS_TMP1,F

LABEL_LG5_2
	DECF SYS_TMP1,F
	BTFSC STATUS,ZERO
	BSF PORTB,4
	BTFSS STATUS,ZERO
	BCF PORTB,4
;***************************************************
; EXKLUSIVODER - Gatter -> LG6
;***************************************************

	CLRF SYS_TMP1
	BTFSS PORTA,0
	GOTO LABEL_LG6_1
	INCF SYS_TMP1,F

LABEL_LG6_1
	BTFSS PORTA,1
	GOTO LABEL_LG6_2
	INCF SYS_TMP1,F

LABEL_LG6_2
	DECF SYS_TMP1,F
	BTFSC STATUS,ZERO
	BCF PORTB,5
	BTFSS STATUS,ZERO
	BSF PORTB,5
;***************************************************
; UND - Gatter -> LG7
;***************************************************

LABEL_LG7_1
	BTFSC PORTA,0
	GOTO LABEL_LG7_FALSE
LABEL_LG7_2
	BTFSS S0,0
	GOTO LABEL_LG7_FALSE

LABEL_LG7_TRUE
	BCF PORTB,6
	GOTO LABEL_LG7_ENDE
LABEL_LG7_FALSE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,6
LABEL_LG7_ENDE
;***************************************************
; UND - Gatter -> LG8
;***************************************************

LABEL_LG8_1
	BTFSS PORTB,6
	GOTO LABEL_LG8_FALSE
LABEL_LG8_2
	BTFSC PORTA,1
	GOTO LABEL_LG8_FALSE

LABEL_LG8_TRUE
	BCF S0,0
	GOTO LABEL_LG8_ENDE
LABEL_LG8_FALSE
	BSF S0,0
LABEL_LG8_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,1
	GOTO LABEL_RS1_RESET
	BTFSS PORTA,0
	GOTO LABEL_RS1_ENDE
	BSF PORTB,7	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,7	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;****************************************

	GOTO MAIN


	END

